label pink_otm_developer_start:
    $ pink.otm.leave_otm()
    call screen pink_developer

label pink_otm_developer_stop:
    $ pink_otm_current_map.stop_running()
    $ pink.otm.return_to_otm()

screen pink_developer:
    vbox:
        text "Press shift+O again to enter the regular console." size 12
        textbutton "Orthogonal Tiled Maps settings" text_size 12 action [Hide("pink_developer"), Show("pink_otm_developer")]
        textbutton "Orthogonal Tiled Maps" text_size 12 action [Hide("pink_developer"), Show("pink_otm_developer_maps")]
        textbutton "Tilesets" text_size 12 action [Hide("pink_developer"), Show("pink_developer_tilesets")]
        textbutton "Sprite Collections" text_size 12 action [Hide("pink_developer"), Show("pink_developer_sprites")]
        textbutton "Return" text_size 12 action Jump("pink_otm_developer_stop")

    key "game_menu" action Jump("pink_otm_developer_stop")


screen pink_otm_developer:
    frame:
        xfill True
        yfill True
        background "#000000"

        hbox:
            frame:
                has vpgrid:
                    cols 1
                    yfill True
                    mousewheel True
                    scrollbars 'vertical'
                    spacing 1

                vbox:
                    xsize 200
                    textbutton "back" text_size 10 action [Hide("pink_otm_developer"), Show("pink_developer")]

            frame:
                has vpgrid:
                    cols 1
                    xfill True
                    yfill True
                    mousewheel True
                    scrollbars 'vertical'
                    spacing 1

                vbox:
                    hbox:
                        $ walk_speed_string = '{:5.2f}'.format(pink_otm_current_map._pc_walk_speed)
                        text "Player walk speed: [walk_speed_string] " size 12
                        textbutton "+" text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.change_walk_speed, pink_otm_current_map._pc_walk_speed + 0.01)
                        textbutton "-" text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.change_walk_speed, max(pink_otm_current_map._pc_walk_speed - 0.01, 0.01))
                    hbox:
                        $ run_speed_string = '{:5.2f}'.format(pink_otm_current_map._pc_run_speed)
                        text "Player run speed: [run_speed_string] " size 12
                        textbutton "+" text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.change_run_speed, pink_otm_current_map._pc_run_speed + 0.01)
                        textbutton "-" text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.change_run_speed, max(pink_otm_current_map._pc_run_speed - 0.01, 0.01))
                    hbox:
                        $ xzoom_string = '{:5.2f}'.format(pink_otm_current_map.camera.xzoom)
                        text "X Zoom: [xzoom_string] " size 12
                        textbutton "++ " text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.camera.set_x_zoom, pink_otm_current_map.camera.xzoom + 0.10)
                        textbutton "+ " text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.camera.set_x_zoom, pink_otm_current_map.camera.xzoom + 0.01)
                        textbutton "- " text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.camera.set_x_zoom, max(pink_otm_current_map.camera.xzoom - 0.01, 0.01))
                        textbutton "--" text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.camera.set_x_zoom, max(pink_otm_current_map.camera.xzoom - 0.10, 0.01))
                    hbox:
                        $ yzoom_string = '{:5.2f}'.format(pink_otm_current_map.camera.yzoom)
                        text "Y Zoom: [yzoom_string] " size 12
                        textbutton "++ " text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.camera.set_y_zoom, pink_otm_current_map.camera.yzoom + 0.10)
                        textbutton "+ " text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.camera.set_y_zoom, pink_otm_current_map.camera.yzoom + 0.01)
                        textbutton "- " text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.camera.set_y_zoom, max(pink_otm_current_map.camera.yzoom - 0.01, 0.01))
                        textbutton "--" text_size 12 xpadding 0 ypadding 0 action Function(pink_otm_current_map.camera.set_y_zoom, max(pink_otm_current_map.camera.yzoom - 0.10, 0.01))
                    hbox:
                        text "Autocenter sprites: [pink_otm_autocenter_sprites]" size 12
                        if pink_otm_autocenter_sprites:
                            textbutton " Disable." text_size 12 xpadding 0 ypadding 0 action SetVariable('pink_otm_autocenter_sprites', False)
                        else:
                            textbutton " Enable." text_size 12 xpadding 0 ypadding 0 action SetVariable('pink_otm_autocenter_sprites', True)
                    hbox:
                        text "Force run: [pink_otm_force_run]" size 12
                        if pink_otm_force_run:
                            textbutton " Turn off" text_size 12 xpadding 0 ypadding 0 action SetVariable('pink_otm_force_run', False)
                        else:
                            textbutton " Turn on" text_size 12 xpadding 0 ypadding 0 action SetVariable('pink_otm_force_run', True)
                    hbox:
                        text "Disable run: [pink_otm_forbid_run]" size 12
                        if pink_otm_forbid_run:
                            textbutton " Turn off" text_size 12 xpadding 0 ypadding 0 action SetVariable('pink_otm_forbid_run', False)
                        else:
                            textbutton " Turn on" text_size 12 xpadding 0 ypadding 0 action SetVariable('pink_otm_forbid_run', True)


screen pink_otm_developer_maps:
    # This screen takes as arguments:
    #
    # sel_filename
    #    Which map to initially select
    default filenames = pink.otm.get_all_map_filenames()
    default sel_filename = filenames[0]
    default tele_x = 0
    default tele_y = 0

    frame:
        xfill True
        yfill True
        background "#000000"

        hbox:
            frame:
                has vpgrid:
                    cols 1
                    yfill True
                    mousewheel True
                    scrollbars 'both'
                    spacing 1

                vbox:
                    xsize 200
                    for filename in filenames:
                        if filename == sel_filename:
                            textbutton "[filename]" text_size 10 text_color '#ffff00' action SetScreenVariable("sel_filename", filename)
                        else:
                            textbutton "[filename]" text_size 10 action SetScreenVariable("sel_filename", filename)
                    textbutton "back" text_size 10 action [Hide("pink_otm_developer_maps"), Show("pink_developer")]

            frame:
                has vpgrid:
                    cols 1
                    xfill True
                    yfill True
                    mousewheel True
                    scrollbars 'vertical'
                    spacing 1

                $ grid_size, tile_size, image_size, layer_count, tiled_version, properties, tilesets = pink.otm.get_map_data(sel_filename)

                vbox:
                    text "Filename: [sel_filename]" size 12 color '#ffff00'
                    text "Tile size (in pixels): [tile_size]" size 12
                    text "Map size (in tiles): [grid_size]" size 12
                    text "Map size (in pixels): [image_size]" size 12
                    text "Nr. of layers: [layer_count]" size 12
                    text "Created in tiled version: [tiled_version]" size 12
                    text "Tilesets:" size 12
                    for tileset_name in tilesets:
                        button:
                            xpadding 0
                            ypadding 0
                            action [Hide("pink_otm_developer_maps"),
                                    Show("pink_developer_tilesets", sel_filename=tileset_name)]
                            text "   [tileset_name]" size 12
                    text "Map-level properties:" size 12
                    for property_str in properties:
                        text "   [property_str]" size 12
                    text "" size 12

                    hbox:
                        textbutton "Teleport to coordinates: " text_size 12 xpadding 0 ypadding 0 action [Hide("pink_otm_developer_maps"), Function(pink.otm.go_to_map, target_map=sel_filename, x_coord=tele_x, y_coord=tele_y)]
                        text "X: [tele_x] " size 12
                        textbutton "+" text_size 12 xpadding 0 ypadding 0 action SetScreenVariable('tele_x', min(tele_x + 1, int(grid_size.split('x')[0])))
                        textbutton "-" text_size 12 xpadding 0 ypadding 0 action SetScreenVariable('tele_x', max(tele_x - 1, 0))
                        text "Y: [tele_y] " size 12
                        textbutton "+" text_size 12 xpadding 0 ypadding 0 action SetScreenVariable('tele_y', min(tele_y + 1, int(grid_size.split('x')[1])))
                        textbutton "-" text_size 12 xpadding 0 ypadding 0 action SetScreenVariable('tele_y', max(tele_y - 1, 0))

screen pink_developer_tilesets:
    # This screen takes as arguments:
    #
    # sel_filename
    #    Which tileset to initially select
    default filenames = pink.otm.get_all_tileset_filenames()
    default sel_filename = filenames[0]

    frame:
        xfill True
        yfill True
        background "#000000"

        hbox:
            frame:
                has vpgrid:
                    cols 1
                    yfill True
                    mousewheel True
                    scrollbars 'both'
                    spacing 1

                vbox:
                    xsize 200
                    for filename in filenames:
                        if filename == sel_filename:
                            textbutton "[filename]" text_size 10 text_color '#ffff00' action SetScreenVariable("sel_filename", filename)
                        else:
                            textbutton "[filename]" text_size 10 action SetScreenVariable("sel_filename", filename)
                    textbutton "back" text_size 10 action [Hide("pink_developer_tilesets"), Show("pink_developer")]

            frame:
                has vpgrid:
                    xfill True
                    yfill True
                    cols 1
                    mousewheel True
                    scrollbars 'vertical'
                    spacing 1

                $ tile_count, tiled_version = pink.otm.get_tileset_data(sel_filename)

                vbox:
                    text "Filename: [sel_filename]" size 12 color '#ffff00'
                    text "Nr. of tiles: [tile_count]" size 12
                    text "Created in tiled version: [tiled_version]" size 12

screen pink_developer_sprites:
    # This screen takes as arguments:
    #
    # sel_filename
    #    Which sprite collection to initially select
    default filenames = pink.otm.get_all_sprite_filenames()
    default sel_filename = filenames[0]

    frame:
        xfill True
        yfill True
        background "#000000"

        hbox:
            frame:
                has vpgrid:
                    cols 1
                    yfill True
                    mousewheel True
                    scrollbars 'both'
                    spacing 1

                vbox:
                    xsize 200
                    for filename in filenames:
                        if filename == sel_filename:
                            textbutton "[filename]" text_size 10 text_color '#ffff00' action SetScreenVariable("sel_filename", filename)
                        else:
                            textbutton "[filename]" text_size 10 action SetScreenVariable("sel_filename", filename)
                    textbutton "back" text_size 10 action [Hide("pink_developer_sprites"), Show("pink_developer")]

            frame:
                has vpgrid:
                    cols 1
                    xfill True
                    yfill True
                    mousewheel True
                    scrollbars 'vertical'
                    spacing 1

                $ animations, pc_sprite = pink.otm.get_sprite_data(sel_filename)

                vbox:
                    text "Filename: [sel_filename]" size 12 color '#ffff00'
                    text "Animations:" size 12
                    for animation in sorted(animations):
                        text "   [animation]" size 12
                    text "Suitable for PC: [pc_sprite]" size 12
                    text ""
                    if pc_sprite:
                        textbutton "Use Sprite" text_size 12 action [Hide("pink_developer_sprites"), Function(pink_otm_current_pc.switch_sprite_collection, sel_filename), Jump("pink_otm_developer_stop")]