## ================================================= GENERAL SETTINGS =================================================
## This variable defines screen tag/layer combinations which should freeze pink engine screens when they're up.
define pink_freeze_game_screens = [('menu', 'screens')]

## =================================================== OTM SETTINGS ===================================================

## Default sprite for the pc on orthogonal tiled maps (otm). Should be a path relative to the game folder.
define pink_otm_default_sprite = "pink_engine/sprite_collections/tutorial pc.json"

## Whether a single tap of the movement key in a direction you are not facing causes your character to move in that
## direction (if True), or only change direction (if False)
define pink_otm_turn_and_move = True

## Whether a character still displays a movement animation when moving in a barred direction
define pink_otm_animate_invalid_move = True

## Movement speed
define pink_otm_default_npc_move_speed = 0.14
define pink_otm_default_pc_walk_speed = 0.14
define pink_otm_default_pc_run_speed = 0.08

## Disables running globally
define pink_otm_disable_run = False

## Default zoom level
define pink_otm_camera_default_zoom = 1.0
define pink_tmd_camera_default_zoom = 1.0

## Viewport settings
define pink_otm_default_viewport_x_offset = 0
define pink_otm_default_viewport_y_offset = 0
define pink_otm_default_viewport_width = config.screen_width
define pink_otm_default_viewport_height = config.screen_height

## Whether to automatically center sprites on tiles if they have been placed along grid lines. Individual sprites can
##  be exempted from autocentering through use of the 'forbid_autocenter' property.
define pink_otm_autocenter_sprites = True

## The animation name used for player movement
define pink_otm_default_walk_animation_name = "walk"
define pink_otm_default_run_animation_name = "run"

## Saving the game while a larger pink engine map is visible takes a fair amount of time, as the entire map needs to
## be put into the save file. This can cause significant lag spikes when gameplay is not paused during saving, such
## as when autosaving during a dialogue choice. As such, config.autosave_on_choice is overridden when a pink engine
## map is visible, preventing autosaves during events. The original config.autosave_on_choice is restored on using
## pink.otm.leave_otm()
define pink_otm_autosave_on_choice = False

## ================================================= DEFAULT SETTINGS =================================================
## An option from the default ren'py, this prevents blurring from occurring when you zoom in. However, it causes some
## slight distortion on all zoom levels, so is disabled by default. Enable if your game uses a lot of close zooms.
define config.nearest_neighbor = False

## Enables the model-based renderer. This helps offload more of the rendering calculations to the GPU, so should improve
## performance.
define config.gl2 = True
