label pink_tmd_call_map(func, *args, **kwargs):
    scene black

    python:
        # Blocks rollback while on a pink engine map.
        if config.rollback_enabled:
            pink_otm_rollback_restore = True
        else:
            pink_otm_rollback_restore = False

        config.rollback_enabled = False
        # if pink_tmd_current_camera is None:
        pink_tmd_current_map.game_tick(0)

    call screen pink_tmd_map(func, *args, **kwargs)

transform pink_tmd_size_offset(screen_width, screen_height, xzoom, yzoom):
    # Centers small screens
    xoffset max(int((screen_width - (pink_tmd_current_map.image_size.x * xzoom)) / 2), 0)
    yoffset max(int((screen_height - (pink_tmd_current_map.image_size.y * yzoom)) / 2), 0)

screen pink_tmd_map(button_func, *args, **kwargs, button_text="Continue"):
    $ map_camera = pink_tmd_current_map.camera
    $ xzoom, yzoom = map_camera.xzoom, map_camera.yzoom
    $ displayable = pink_tmd_current_map.get_displayable()

    add pink_tmd_current_map

    viewport:
        xadjustment map_camera.x
        yadjustment map_camera.y
        draggable True  # TODO REMOVE

        at pink_tmd_size_offset(config.screen_width, config.screen_height, xzoom, yzoom)
        id "map_viewport"
        area (0, 0, config.screen_width, config.screen_height)

        fixed:
            xsize pink_tmd_current_map.image_size.x
            ysize pink_tmd_current_map.image_size.y
            at pink_otm_map_zoom(xzoom, yzoom)
            add displayable

    textbutton button_text action [Hide('pink_tmd_map'), Function(button_func, *args, **kwargs)]
